package bcrypt

const (
	Name string = "bcrypt"
	// DefaultRounds is the default per OpenSSH, not per the bcrypt_pbkdf spec itself. It is recommended to use e.g. 100 rounds.
	DefaultRounds uint32 = 16
	// DefaultSaltLen is the default per OpenSSH, not per the bcrypt_pbkdf spec itself.
	DefaultSaltLen int = 16
	// DefaultKeyLen is suitable for AES256-CTR but may not be for others. TODO: revisit this and find something more flexible?
	DefaultKeyLen uint32 = 48
)
