package ed25519

import (
	`crypto/ed25519`

	`r00t2.io/sshkeys/cipher`
	`r00t2.io/sshkeys/kdf`
)

// Key is an ed25519 OpenSSH key.
type Key struct {
	KeyPairs []*Keypair `xml:"keypairs" json:"keypairs" yaml:"Keypairs"`
	Cipher   cipher.Cipher
	KDF      kdf.KDF
}

type Keypair struct {
	Private ed25519.PrivateKey `xml:"private" json:"private_key" yaml:"Private Key"`
	Public  ed25519.PublicKey  `xml:"public" json:"public_key" yaml:"Public Key"`
	Comment string             `xml:"comment,attr" json:"comment" yaml:"comment"`
}
